import 'package:http/http.dart' as http;
import 'package:spyce/spyce.dart';

class GithubApi extends Job {
  String user;

  GithubApi(this.user) : super('https://api.github.com/users/$user/repos');

  @override
  Future<void> exec(Spyce spyce, Service service) async {
    print((await service['http'].get(name)).body);
  }
}

Future<void> main(List<String> args) async {
  var user = args.isNotEmpty ? args[0] : 'github';
  var service = Service();
  service['http'] = http.Client();
  var runner = Runner('localhost', service, 1);
  var spyce = Spyce('spyce');
  spyce.addRunner(runner);
  spyce.logStream.listen(print);
  spyce.addPipeline(Pipeline(
      'githubApi',
          () sync* {
        yield GithubApi(user);
      }()
          .iterator));
}
